
#define lcd_type 2           // 0=5x7, 1=5x10, 2=2 lines



// These bytes need to be sent to the LCD to start it up.
byte CONST LCD_INIT_STRING[4] = {0x20 | (lcd_type << 2), 0xc, 1, 6};

// 0x20 = 100000|1000 ^= 2 Zeilen-Display;   mit lcd_type=2=10(BIN) ???
// 0xc  = 1100 ^= Display an
// 1    = Display lschen
// 6    = 110 = Adresspointer inkrementieren und Displayinhalt nicht schieben

/*byte lcd_read_byte() {
      byte low,high;

      set_tris_b(LCD_READ);
      portb.rw = 1;
      nop();
      portb.enable = 1;
      nop();
      high = portb.lcddata;
      portb.enable = 0;
      nop();
      portb.enable = 1;
      delay_us(1);
      low = portb.lcddata;
      portb.enable = 0;
      set_tris_b(LCD_WRITE);
      return( (high<<4) | low);
}
*/
void lcd_send_nibble( byte n ) {
      portb.lcddata = n;
      nop();
      portb.enable = 1;
      delay_us(2);
      portb.enable = 0;
}

void lcd_send_byte( byte address, byte n ) {
      portb.rs = 0;

      delay_ms(2);
      portb.rs = address;
      nop();
      //portb.rw = 0;
      //nop();
      portb.enable = 0;
      lcd_send_nibble(n >> 4);
      lcd_send_nibble(n & 0xf);
}

void lcd_init() {
    byte i;


    portb.rs = 0;               // siehe 4-Bit Initialisierung (LCD-Datenblatt)
    //portb.rw = 0;
    portb.enable=0;
    delay_ms(15);  // 15 ms Pause
    for(i=1;i<=3;++i) {
       lcd_send_nibble(3);      // 3-mal 0011 mit mind. 5ms Pause
       delay_ms(5);
    }
    lcd_send_nibble(2);         // 0010 = 4-Bit Interface
    for(i=0;i<=3;++i)
       lcd_send_byte(0,LCD_INIT_STRING[i]);
}

void lcd_gotoxy( byte x, byte y) {
   byte address;

   if (y==1) address=0;
   if (y==2) address=0x40;
   if (y==3) address=0x10;
   if (y==4) address=0x50;
   address+=x-1;
   lcd_send_byte(0,0x80|address);
}

void lcd_putc( char c) {
 switch (c) {
     case '\f'   : lcd_send_byte(0,1);
                   delay_ms(2);
                                           break;
     case '\1'   : lcd_gotoxy(1,1);        break;
     case '\2'   : lcd_gotoxy(1,2);        break;
     case '\3'   : lcd_gotoxy(1,3);        break;
     case '\4'   : lcd_gotoxy(1,4);        break;
     case '\b'   : lcd_send_byte(0,0x10);   break;
     default     : lcd_send_byte(1,c);     break;
 }
}


