#include "pcf8583.h"
#include "lcd16x2.h"


void main()
{
   set_tris_a(0);
   set_tris_b(BIT0+BIT2);
   set_tris_c(BIT0+BIT1+BIT2+BIT7);

   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_CLOCK_DIV_2);
   setup_spi(FALSE);
   setup_counters(RTCC_INTERNAL,RTCC_DIV_2);
   setup_timer_1(T1_DISABLED);

   setup_ccp1(CCP_OFF);
   ext_int_edge(L_TO_H);
   
   lcd_init();                // Initialisierung der LCD-Anzeige
   delay_ms(50);
   Gettime ();
   delay_ms(500);
   min_vorher=60;

   while (1)
   {
     Gettime();
     GetDate();
     if (zeit[0]!=min_vorher )
     {
         lcd_gotoxy(1,1);
         printf(lcd_putc,"\fZeit: %02u:%02u:%02u",zeit[2],zeit[1],zeit[0]);
         lcd_gotoxy(1,2);
         printf(lcd_putc,"Datum: %02u.%02u.%02u",zeit[5],zeit[4],zeit[3]);
         min_vorher=zeit[0];
     }
     if (INPUT(SETZEIT))
     {
       delay_ms(2000);
       if (INPUT(SETZEIT))
       {
         zeit[3]=1;
         zeit[4]=1;
         zeit[5]=1;
         Z=1;
         y=15;
         SET_FERTIG=0;
         while (!SET_FERTIG)
         {
            while (INPUT(SETZEIT));
            lcd_gotoxy(1,2);
            lcd_putc("                ");
            lcd_gotoxy(1,3);
            lcd_putc("                ");
            lcd_gotoxy(1,4);
            lcd_putc("                ");
            lcd_gotoxy(y,2);
            lcd_putc("**");

            while (!INPUT(SETZEIT))
            {
               if (INPUT(SET_PLUS))
               {
                  delay_ms(2);
                  while(INPUT(SET_PLUS));

                  if (zeit[z]==59 && z==0) zeit[z]=0;
                  if (zeit[z]==59 && z==1) zeit[z]=0;
                  else if (zeit[z]==23 && z==2) zeit[z]=0;
                  else if (zeit[z]==12 && z==4) zeit[z]=1;
                  else if (zeit[z]==31 && z==5)
                  {
                     if (zeit[4]==1 || zeit[4]==3 || zeit[4]==5 || zeit[4]==7 || zeit[4]==8 || zeit[4]==10 || zeit[4]==12) zeit[z]=1;
                  }
                  else if (zeit[z]==30 && z==5 && (zeit[4]==4 || zeit[4]==6 || zeit[4]==9 || zeit[4]==11)) zeit[z]=1;
                  else if (zeit[z]==29 && z==5 && (zeit[4]==2 && zeit[6]==0)) zeit[z]=1;
                  else if (zeit[z]==28 && z==5 && zeit[4]==2 && (zeit[6]!=0)) zeit[z]=1;
                  else if (zeit[z]==99 && z==3) zeit[z]=0;
                  else zeit[z]++;
                  lcd_gotoxy(1,1);
                  printf(lcd_putc,"\fZeit: %02u:%02u:%02u",zeit[2],zeit[1],zeit[0]);
                  lcd_gotoxy(1,2);
                  printf(lcd_putc,"Datum: %02u.%02u.%02u",zeit[5],zeit[4],zeit[3]);
                  lcd_gotoxy(y,3);
                  lcd_putc("**");
               }
               else if (INPUT(SET_MINUS))
               {
                  delay_ms(2);
                  while(INPUT(SET_MINUS));
                  if (zeit[z]==0 && z==0) zeit[z]=59;
                  if (zeit[z]==0 && z==1) zeit[z]=59;
                  else if (zeit[z]==0 && z==2) zeit[z]=23;
                  else if (zeit[z]==0 && z==3) zeit[z]=99;
                  else if (zeit[z]==1 && z==4) zeit[z]=12;
                  else if (zeit[z]==1 && z==5)
                  {
                        if (zeit[4]==1 || zeit[4]==3 || zeit[4]==5 || zeit[4]==7 || zeit[4]==8 || zeit[4]==10 || zeit[4]==12) zeit[z]=31;
                        else if (zeit[4]==4 || zeit[4]==6 || zeit[4]==9 || zeit[4]==11) zeit[z]=30;
                        else if (zeit[z]==1 && z==5 && zeit[4]==2 && zeit[6]==0) zeit[z]=29;
                        else if (zeit[z]==1 && z==5 && zeit[4]==2 && zeit[6]!=0) zeit[z]=28;
                  }
                  else zeit[z]--;
                  lcd_gotoxy(1,1);
                  printf(lcd_putc,"\fZeit: %02u:%02u:%02u",zeit[2],zeit[1],zeit[0]);
                  lcd_gotoxy(1,2);
                  printf(lcd_putc,"Datum: %02u.%02u.%02u",zeit[5],zeit[4],zeit[3]);
                  lcd_gotoxy(y,2);
                  lcd_putc("**");
               }
            } // Ende while (!INPUT(SETZEIT))
            delay_ms(2000);
            if (!INPUT(SETZEIT))
            {
               if (z==5) z=1;
               else z++;
               if (y==12) y=10;
               if (y==1) y=15;
               else y-=3;
            }
            else
            {
               setdate_time();
               SET_FERTIG=1;
            }
         } // Ende while (!SET_FERTIG)

      } // Ende if (INPUT(SETZEIT))
  } // Ende else
 } // Ende while (1)






}
