#include <16f873.h>
#use delay(clock=4000000)
#fuses XT,NOWDT,NOLVP
#use i2c(master,sda=PIN_C4,scl=PIN_C3)




enum BITSTELLE { Bit0=1,BIT1=2,BIT2=4,BIT3=8,BIT4=16,BIT5=32,BIT6=64,BIT7=128 };

char z,blink,y,a;
char sek,min,std,Monat,tag,min_vorher,sek_vorher,Jd,blank,jahr,dow;
char zeit[10];
char DATA_IN,mask,test;

char   div_flag;




#define     SETZEIT           PIN_C0
#define     SET_MINUS         PIN_C1
#define     SET_PLUS          PIN_C2
#define     EEPROM_SCL        PIN_C3
#define     EEPROM_SDA        PIN_C4


#bit        SET_FERTIG     = Div_Flag.0


struct port_b_layout
{         // Layout des Ports B
                     short blank;   // freier Portpin
                     short rs;         // LCD RS
                     short reset;         // LCD RW
                     short enable;     // LCD ENABLE
                     int lcddata:4;    // LCD-Daten D4...D7
} portb;


#define NOP()  { #asm  nop #endasm  }

#byte porta=5
#byte portb=6


byte decD2hexD( byte value)
{
  return ( value%10 + 16 * (value/10));
}

byte hexD2decD( byte value)
{
  return ( value%16 + 10 * (value/16));
}

void write_rtc(byte address, byte data)
{
 i2c_start();		//I2C Start
 i2c_write(0xa0);	//Chip Address
 i2c_write(address);	//Memory location
 i2c_write(data);	//Data
 i2c_stop();		//I2C Stop
 return;
}

// Memory location read function.
byte read_rtc(byte address)
{
 byte data;


 i2c_start();		//I2C Start
 i2c_write(0xa0);	//Chip address
 i2c_write(address);	//Memory location
 i2c_start();		//I2C Start
 i2c_write(0xa1);	//Read function
 data=i2c_read(0);	//Read 8 bits of data
 i2c_stop();		//I2C Stop
 return(data);		//Return with data
}


void Setdate_time()
  {
   int var=0;


//write Year to RAM location
jahr=decD2hexD(zeit[3]);
monat=decD2hexD(zeit[4]);
tag=decD2hexD(zeit[5]);
std=decD2hexD(zeit[2]);
min=decD2hexD(zeit[1]);
sek=decD2hexD(zeit[0]);

// write_rtc(0x10,jahr);

//write Year and Day
 write_rtc(0x10,jahr);
 var=jahr&0x03;
 write_rtc(0x11,var);
 jahr=var<<6;
 var=tag&0x3F;
 tag=jahr+var;
 write_rtc(0x05,tag);

//write Day of week and month
 dow=(dow-1)<<5;
 monat=(monat&0x1F)+dow;
 write_rtc(0x06,monat);
//write hour
 write_rtc(0x04,std);
//write minute
 write_rtc(0x03,min);
//clear seconds and tenths of seconds
 write_rtc(0x02,sek);
 write_rtc(0x01,0);
 return;




 }


void Gettime ()
{

 std  = read_rtc(0x04)&0x3F;
 min = read_rtc(0x03);
 sek = read_rtc(0x02);

 zeit[0]=hexd2decD(sek);
 zeit[1]=hexd2decD(min);
 zeit[2]=hexd2decD(std);
}


void GetDate()
{
 int var_l=0,var_h=0,flag;
 tag  = read_rtc(0x05)&0x3F;
 monat  = read_rtc(0x06)&0x1F;
 //format years. Chip only counts 4 years so hold year in ram 0x10
 // detect year change by comparing with ram 0x11
 jahr = (read_rtc(0x05)&0xC0)>>6;
 zeit[6]=jahr;
 flag=read_rtc(0x11);
 if(jahr!=flag)
  {flag=jahr;
   var_l=read_rtc(0x10);
   var_l++;
   if((var_l&0xf)>9)
    {
     var_l=var_l&0xF0;
     var_l=var_l+0x10;
    }
   write_rtc(0x10,var_l);
   write_rtc(0x11,flag);
  }
 jahr =read_rtc(0x10);

 //format day of weeks
 dow  = (read_rtc(0x06)&0xE0)>>5;
 dow  = dow+1;


 zeit[3]=hexd2decD(jahr);
 zeit[4]=hexd2decD(monat);
 zeit[5]=hexd2decD(tag);
 return;



}


